#include <dbus/dbus-glib.h>

int
main ()
{
  GError *error = NULL;

  DBusGConnection *connection = NULL;
  DBusGProxy *proxy = NULL;
  gchar *result = NULL;
  gchar *address = NULL;
  int retval = 1;

  g_type_init ();

  if (!g_file_get_contents ("server-address.txt", &address, NULL, &error)) 
    goto out;

  g_print ("connecting to `%s'\n", address);
  connection = dbus_g_connection_open (address, &error);

  if (!connection) 
    goto out;

  g_print ("connection: %p\n", connection);

  proxy = dbus_g_proxy_new_for_peer (connection, 
                                     "/com/openismus/Yadda",
                                     "com.openismus.Yadda");

  g_print ("proxy: %p\n", proxy);

  if (!dbus_g_proxy_call (proxy, "HelloWorld", &error,
                          G_TYPE_STRING, "yadda",
                          G_TYPE_INVALID,
                          G_TYPE_STRING, &result,
                          G_TYPE_INVALID))
    goto out;

  g_print ("success: `%s'\n", result);
  retval = 0;

out:
  if (error)
    {
      g_warning ("%s", error->message);
      g_error_free (error);
    }

  if (connection)
    dbus_g_connection_unref (connection);

  g_free (address);

  return retval;
}
