#ifndef EGG_SERVICE_INCLUDED
#define EGG_SERVICE_INCLUDED

#include <glib-object.h>

G_BEGIN_DECLS

#define EGG_TYPE_SERVICE           (egg_service_get_type())
#define EGG_SERVICE(obj)           (G_TYPE_CHECK_INSTANCE_CAST((obj), EGG_TYPE_SERVICE, EggService))
#define EGG_SERVICE_CLASS(cls)     (G_TYPE_CHECK_CLASS_CAST((cls), EGG_TYPE_SERVICE, EggServiceClass))
#define EGG_IS_SERVICE(obj)        (G_TYPE_CHECK_INSTANCE_TYPE((obj), EGG_TYPE_SERVICE))
#define EGG_IS_SERVICE_CLASS(cls)  (G_TYPE_CHECK_CLASS_TYPE((cls), EGG_TYPE_SERVICE))
#define EGG_SERVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj), EGG_TYPE_SERVICE, EggServiceClass))

typedef struct _EggService          EggService;
typedef struct _EggServiceClass     EggServiceClass;
typedef struct _EggServicePrivate   EggServicePrivate;

struct _EggService
{
  GObject parent_instance;
  EggServicePrivate *priv;
};

struct _EggServiceClass
{
  GObjectClass parent_class;
};

GType       egg_service_get_type (void) G_GNUC_CONST;
EggService* egg_service_new      (const char *description,
                                  const char *service_type,
                                  const char *address);

void        egg_service_start    (EggService *self);
void        egg_service_stop     (EggService *self);

void        egg_service_publish  (EggService *self,
                                  const char *path,
                                  GObject    *object);

#endif /* EGG_SERVICE_INCLUDED */
