#include "eggservice.h"

typedef struct { GObject parent_instance; } GlomYadda;
typedef struct { GObjectClass parent_class; } GlomYaddaClass;

G_DEFINE_TYPE(GlomYadda, glom_yadda, G_TYPE_OBJECT)

static gboolean
glom_yadda_hello_world (GlomYadda   *self G_GNUC_UNUSED,
                        const char  *str,
                        char       **retstr,
                        GError      **error G_GNUC_UNUSED)
{
  g_print ("got: `%s'\n", str);

  *retstr = g_utf8_strreverse (str, -1);
  g_print ("sending: `%s'\n", *retstr);

  return TRUE;
}

#include "server-dbus.h"

static void
glom_yadda_init (GlomYadda *self G_GNUC_UNUSED)
{
}

static void
glom_yadda_class_init (GlomYaddaClass *cls G_GNUC_UNUSED)
{
  dbus_g_object_type_install_info (glom_yadda_get_type (),
                                   &dbus_glib_glom_object_info);
}

int
main (void)
{
  EggService *service;
  GMainLoop *loop;
  GObject *yadda;

  g_set_application_name ("Yadda Server Test");

  g_type_init ();

  service = egg_service_new (NULL, "_glom._tcp", NULL);

  yadda = g_object_new (glom_yadda_get_type (), NULL);
  egg_service_publish (service, "/com/openismus/Yadda", yadda);
  g_object_unref (yadda);

  egg_service_start (service);

  loop = g_main_loop_new (NULL, FALSE);
  g_main_loop_run (loop);
  g_main_loop_unref (loop);

  g_object_unref (service);

  return 0;
}
